VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6615
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   8760
   LinkTopic       =   "Form1"
   ScaleHeight     =   6615
   ScaleWidth      =   8760
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   5955
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   1
      Text            =   "Form1.frx":0000
      Top             =   570
      Width           =   8625
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Toggle Mute"
      Height          =   465
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2235
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' IAudioEndpointVolumeCallback
' !!! Dont use. VB will crash !!!

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const API_FALSE As Long = &H0&
Private Const API_TRUE As Long = &H1&

Private Const CLSCTX_INPROC_SERVER As Long = &H1&
Private Const CLSCTX_INPROC_HANDLER As Long = &H2&
Private Const CLSCTX_LOCAL_SERVER As Long = &H4&
Private Const CLSCTX_REMOTE_SERVER As Long = &H10&
Private Const CLSCTX_ALL As Long = CLSCTX_INPROC_SERVER Or _
                                   CLSCTX_INPROC_HANDLER Or _
                                   CLSCTX_LOCAL_SERVER Or _
                                   CLSCTX_REMOTE_SERVER

Private Const CLSID_MyContext As String = "{5929DCA2-52B8-449B-8A58-FDF6750634DA}"
Private Const CLSID_MMDeviceEnumerator As String = "{BCDE0395-E52F-467C-8E3D-C4579291692E}"
Private Const IID_IMMDeviceEnumerator As String = "{A95664D2-9614-4F35-A746-DE8DB63617E6}"
Private Const IID_IAudioEndpointVolume As String = "{5CDF2C82-841E-4546-9722-0CF74078229A}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    QueryInterface = 0
    Activate = 3
    RegisterControlChangeNotify = 3
    UnregisterControlChangeNotify = 4
    GetDefaultAudioEndpoint = 4
    SetMute = 14
    GetMute = 15
End Enum

Private Enum ERole
    eConsole = &H0&
    eMultimedia = &H1&
    eCommunications = &H2&
End Enum

Private Enum EDataFlow
    eRender = &H0&
    eCapture = &H1&
    eAll = &H2&
End Enum

Private Type AUDIO_VOLUME_NOTIFICATION_DATA
    guidEventContext As GUID
    bMuted As Long
    fMasterVolume As Single
    nChannels As Long
    sfChannelVolumes(0) As Single
End Type

' ----==== Variablen ====----
Private pIMMDevice As Long
Private pIMMDeviceEnumerator As Long
Private pIAudioEndpointVolume As Long

'Private WithEvents cIAudioEndpointVolumeCallback As clsIAEVCallback
'
'Private Sub cIAudioEndpointVolumeCallback_OnNotify(ByVal pNotify As Long)
'
'    Dim lItem As Long
'    Dim fChannelVolumes() As Single
'    Dim tAVND As AUDIO_VOLUME_NOTIFICATION_DATA
'
'    Text1.Text = vbNullString
'
'    Call CopyMemory(tAVND, ByVal pNotify, Len(tAVND))
'
'    With tAVND
'        Call AddText("guidEventContext = " & Guid2Str(.guidEventContext))
'        Call AddText("bMuted = " & CStr(CBool(.bMuted)))
'        Call AddText("fMasterVolume = " & CStr(.fMasterVolume))
'        Call AddText("nChannels = " & CStr(.nChannels))
'    End With
'
'    If tAVND.nChannels > 1 Then
'
'        ReDim fChannelVolumes(tAVND.nChannels - 1)
'
'        Call CopyMemory(fChannelVolumes(0), ByVal pNotify + Len(tAVND) - 4, 4 * tAVND.nChannels)
'
'        For lItem = 0 To tAVND.nChannels - 1
'
'            Call AddText("sfChannelVolumes(" & CStr(lItem) & ") = " & CStr(fChannelVolumes(lItem)))
'
'        Next
'
'    Else
'
'        Call AddText("sfChannelVolumes(0) = " & CStr(tAVND.sfChannelVolumes(0)))
'
'    End If
'
'End Sub

Private Sub Form_Load()
    
    Dim ptGUID As Long
    Dim ppIMMDevice As Long
    Dim ppIAudioEndpointVolume As Long
    
    Text1.Text = vbNullString
    
    
    If InitInterface(pIMMDeviceEnumerator, CLSID_MMDeviceEnumerator, _
        IID_IMMDeviceEnumerator) = True Then
        
        Call AddText("IMMDeviceEnumerator created")
    
        ppIMMDevice = VarPtr(pIMMDevice)
        
        If Invoke(pIMMDeviceEnumerator, GetDefaultAudioEndpoint, EDataFlow.eRender, _
            ERole.eConsole, ppIMMDevice) = S_OK Then
        
            Call AddText("IMMDevice created")
            
            ptGUID = VarPtr(Str2Guid(IID_IAudioEndpointVolume))
            ppIAudioEndpointVolume = VarPtr(pIAudioEndpointVolume)
            
            If Invoke(pIMMDevice, Activate, ptGUID, CLSCTX_ALL, 0&, _
                ppIAudioEndpointVolume) = S_OK Then
            
                Call AddText("IAudioEndpointVolume created")
            
' Dont use. VB will crash!!!
'
'                Set cIAudioEndpointVolumeCallback = New clsIAEVCallback
'                Call AddText("IAudioEndpointVolumeCallback InferfacePtr = " & _
'                    CStr(cIAudioEndpointVolumeCallback.GetIPtr))
'
'                If Invoke(pIAudioEndpointVolume, RegisterControlChangeNotify, _
'                    cIAudioEndpointVolumeCallback.GetIPtr) = S_OK Then
'
'                    Call AddText("IAudioEndpointVolume::RegisterControlChangeNotify = OK")
'
'                End If

            End If
            
        End If
    
    End If

End Sub

Private Sub Command1_Click()
    
    Dim ptGUID As Long
    Dim lMuteState As Long
    Dim plMuteState As Long
    
    If pIAudioEndpointVolume <> 0& Then
    
        ptGUID = VarPtr(Str2Guid(CLSID_MyContext))
        plMuteState = VarPtr(lMuteState)
    
        If Invoke(pIAudioEndpointVolume, GetMute, plMuteState) = S_OK Then
        
            Call AddText("IAudioEndpointVolume::GetMute = " & CStr(CBool(lMuteState)))
    
            If lMuteState = API_FALSE Then
                
                ' GUID_NULL
                'Call Invoke(pIAudioEndpointVolume, SetMute, API_TRUE, 0&)
                
                If Invoke(pIAudioEndpointVolume, SetMute, API_TRUE, ptGUID) = S_OK Then
                    Call AddText("IAudioEndpointVolume::SetMute = OK")
                End If
            
            Else
                
                ' GUID_NULL
                'Call Invoke(pIAudioEndpointVolume, SetMute, API_FALSE, 0&)
                
                If Invoke(pIAudioEndpointVolume, SetMute, API_FALSE, ptGUID) = S_OK Then
                    Call AddText("IAudioEndpointVolume::SetMute = OK")
                End If
            
            End If
        
        End If
        
    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

    If pIAudioEndpointVolume <> 0& Then

'        If Not cIAudioEndpointVolumeCallback Is Nothing Then
'
'            If Invoke(pIAudioEndpointVolume, UnregisterControlChangeNotify, _
'                cIAudioEndpointVolumeCallback.GetIPtr) = S_OK Then
'
'                Debug.Print _
'                    "IAudioEndpointVolume::UnregisterControlChangeNotify = OK"
'
'            End If
'
'            Debug.Print "IAudioEndpointVolumeCallback InferfacePtr = " & CStr( _
'                cIAudioEndpointVolumeCallback.GetIPtr)
'
'            Set cIAudioEndpointVolumeCallback = Nothing
'
'            Debug.Print "Release IAudioEndpointVolumeCallback = OK"

            Call Release(pIAudioEndpointVolume)

            If pIAudioEndpointVolume = 0& Then

                Debug.Print "Release IAudioEndpointVolume = OK"

            End If

'        End If

    End If

    If pIMMDevice <> 0& Then

        Call Release(pIMMDevice)

        If pIMMDevice = 0& Then

            Debug.Print "Release IMMDevice = OK"

        End If

    End If

    If pIMMDeviceEnumerator <> 0& Then

        Call Release(pIMMDeviceEnumerator)

        If pIMMDeviceEnumerator = 0& Then

            Debug.Print "Release IMMDeviceEnumerator = OK"

        End If

    End If

End Sub

Private Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = modInterface.OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

Private Sub Release(ByRef pInterface As Long)

    If pInterface <> 0& Then
    
        Call modInterface.ReleaseInterface(pInterface)
        
    End If
    
End Sub

Private Sub AddText(ByVal sStr As String)

    Text1.Text = Text1.Text & sStr & vbNewLine

End Sub

